<template>
  <div>
    <div class="table statistic clicks">
      <div class="row title">
        <div class="col w-0">
          <div class="item name">
            <div class="kit sorting">
              <span class="label">{{ mainRowName }}</span>
              <span
                class="direction old"
                :class="getSortClass('group')"
                @click="toggleSorting('group')"/>
            </div>
          </div>
        </div>

        <div
          v-if="struct.col1"
          class="col w-1">
          <div
            v-if="struct.col1.name"
            class="row">
            <div class="item">
              <span
                v-html="struct.col1.name"
                class="label"/>
              <div
                v-if="helpers.col1"
                class="question">
                <div
                  class="button"
                  v-tooltip="{
                    ...tooltipParams,
                    content: `<div class=help-statistics-click><p>${helpers.col1}</p></div>`,
                }"/>
              </div>
            </div>
          </div>
          <div class="row">
            <div
              v-for="structItem in struct.col1.items"
              :key="structItem.key"
              class="item">
              <div class="kit sorting">
                <span
                  class="label"
                  v-html="structItem.label"/>
                <span
                  class="direction old"
                  :class="getSortClass(structItem.key)"
                  @click="toggleSorting(structItem.key)"/>
              </div>
            </div>
          </div>
        </div>

        <div
          v-if="struct.col2"
          class="col w-2">
          <div
            v-if="struct.col2.name"
            class="row">
            <div class="item">
              <span
                v-html="struct.col2.name"
                class="label"/>
              <div
                v-if="helpers.col2"
                class="question">
                <div
                  class="button"
                  v-tooltip="{
                    ...tooltipParams,
                    content: `<div class=help-statistics-click><p>${helpers.col2}</p></div>`,
                }"/>
              </div>
            </div>
          </div>
          <div class="row">
            <div
              v-for="structItem in struct.col2.items"
              :key="structItem.key"
              class="item">
              <div class="kit sorting">
                <span
                  class="label"
                  v-html="structItem.label"/>
                <span
                  class="direction old"
                  :class="getSortClass(structItem.key)"
                  @click="toggleSorting(structItem.key)"/>
              </div>
            </div>
          </div>
        </div>

        <div
          v-if="struct.col3"
          class="col w-3">
          <div
            v-if="struct.col3.name"
            class="row">
            <div class="item">
              <span
                v-html="struct.col3.name"
                class="label"/>
              <div
                v-if="helpers.col3"
                class="question">
                <div
                  class="button"
                  v-tooltip="{
                    ...tooltipParams,
                    content: `<div class=help-statistics-click><p>${helpers.col3}</p></div>`,
                }"/>
              </div>
            </div>
          </div>
          <div class="row">
            <div
              v-for="(structItem, index) in struct.col3.items"
              :key="structItem.key"
              class="item"
              :class="{ 'w-4': index === struct.col3.items.length - 1 }">
              <div class="kit sorting">
                <span
                  class="label"
                  v-html="structItem.label"/>
                <span
                  class="direction old"
                  :class="getSortClass(structItem.key)"
                  @click="toggleSorting(structItem.key)"/>
              </div>
            </div>
          </div>
        </div>
      </div>

      <div
        v-if="totalData!==null"
        class="row body total">
        <div class="row w-0">
          <div class="item">Итого:</div>
        </div>

        <div
          v-if="struct.col1"
          class="row w-1">
          <div
            v-for="structItem in struct.col1.items"
            :key="structItem.key"
            class="item">
            {{ totalData[structItem.key] }}
          </div>
        </div>

        <div
          v-if="struct.col2"
          class="row w-2">
          <div
            v-for="structItem in struct.col2.items"
            :key="structItem.key"
            class="item">
            {{ totalData[structItem.key] }}
          </div>
        </div>

        <div
          v-if="struct.col3"
          class="row w-3">
          <div
            v-for="(structItem, index) in struct.col3.items"
            :key="structItem.key"
            class="item"
            :class="{ 'w-4': index === struct.col3.items.length - 1 }">
            {{ totalData[structItem.key] }}
          </div>
        </div>
      </div>

      <template v-if="rootItem!==null">
        <group-body
          v-for="(it0, index0) in rootItem.data.items"
          :key="'l0'+index0"
          :group="rootItem.request.groupBy"
          :struct="struct"
          :number="index0+1"
          @try-load="onTryLoad"
          :item="it0">
          <template
            v-if="it0.data!==null && it0.data.items.length>0"
            slot="content">
            <group-body
              v-for="(it1, index1) in it0.data.items"
              :key="'l1'+index1"
              :group="it0.request.groupBy"
              :struct="struct"
              @try-load="onTryLoad"
              :item="it1">
              <template
                v-if="it1.data!==null && it1.data.items.length>0"
                slot="content">
                <group-body
                  v-for="(it2, index2) in it1.data.items"
                  :key="'l2'+index2"
                  :group="it1.request.groupBy"
                  :struct="struct"
                  @try-load="onTryLoad"
                  :item="it2">
                  <template
                    v-if="it2.data!==null && it2.data.items.length>0"
                    slot="content">
                    <group-body
                      v-for="(it3, index3) in it2.data.items"
                      :key="'l3'+index3"
                      :group="it2.request.groupBy"
                      :struct="struct"
                      @try-load="onTryLoad"
                      :item="it3">
                      <template
                        v-if="it3.data!==null && it3.data.items.length>0"
                        slot="content">
                        <group-body
                          v-for="(it4, index4) in it3.data.items"
                          :key="'l4'+index4"
                          :group="it3.request.groupBy"
                          :struct="struct"
                          @try-load="onTryLoad"
                          :item="it4"/>
                        <div
                          class="block more"
                          v-if="it3.data.itemsMeta.count < it3.data.itemsMeta.total">
                          <button
                            type="button"
                            class="button"
                            @click="loadNext(it3)">Показать ещё</button>
                          <div class="count">
                            Показано {{ it3.data.itemsMeta.count }}
                            из {{ it3.data.itemsMeta.total }}
                          </div>
                        </div>
                      </template>
                    </group-body>
                    <div
                      class="block more"
                      v-if="it2.data.itemsMeta.count < it2.data.itemsMeta.total">
                      <button
                        type="button"
                        class="button"
                        @click="loadNext(it2)">Показать ещё</button>
                      <div class="count">Показано {{ it2.data.itemsMeta.count }} из {{ it2.data.itemsMeta.total }}</div>
                    </div>
                  </template>
                </group-body>
                <div
                  class="block more"
                  v-if="it1.data.itemsMeta.count < it1.data.itemsMeta.total">
                  <button
                    type="button"
                    class="button"
                    @click="loadNext(it1)">Показать ещё</button>
                  <div class="count">Показано {{ it1.data.itemsMeta.count }} из {{ it1.data.itemsMeta.total }}</div>
                </div>
              </template>
            </group-body>
            <div
              class="block more"
              v-if="it0.data.itemsMeta.count < it0.data.itemsMeta.total">
              <button
                type="button"
                class="button"
                @click="loadNext(it0)">Показать ещё</button>
              <div class="count">Показано {{ it0.data.itemsMeta.count }} из {{ it0.data.itemsMeta.total }}</div>
            </div>
          </template>
        </group-body>
      </template>
    </div>
    <div
      class="block more end"
      v-if="rootItem!==null && rootItem.data.itemsMeta.count < rootItem.data.itemsMeta.total">
      <button
        type="button"
        class="button"
        @click="loadNext(rootItem)">Показать ещё</button>
      <div class="count">Показано {{ rootItem.data.itemsMeta.count }} из {{ rootItem.data.itemsMeta.total }}</div>
    </div>
  </div>

</template>

<script>
import GroupBody from '~/components/redesign/cabinet/statistics/group-body';
import { get, set, clone } from 'lodash-es';
import dayjs from 'dayjs';
import customParseFormat from 'dayjs/plugin/customParseFormat';
import weekOfYear from 'dayjs/plugin/weekOfYear';

dayjs.extend(customParseFormat);
dayjs.extend(weekOfYear);

export default {
  name: 'ResultTableClicks',
  components: { GroupBody },
  props: {
    filter: {
      type: Object,
      required: true,
    },
    groupingRef: {
      type: Array,
      required: true,
    },
    loader: {
      type: Function,
      required: true,
    },
    bus: {
      type: Object,
      required: true,
    },
    struct: {
      type: Object,
      required: true,
    },
    helpers: {
      type: Object,
      required: true,
    },
  },
  data() {
    return {
      totalData: null,
      totalMeta: null,
      rootItem: null,
      pageSize: 10,
      sorting: {
        column: null,
        dir: null,
      },
      globalFrom: null,
      globalTo: null,
      loading: false,
      tooltipParams: {
        classes: 'tooltip kit white',
        trigger: 'hover',
        offset: '4',
        placement: 'bottom',
        html: 'true',
      },
    };
  },
  computed: {
    mainRowName() {
      const group = this.groupingRef.find(ref => ref.value === this.filter.group[0]);
      if (group) {
        return group.text;
      }
      return 'Номер товара';
    },
  },
  watch: {
    filter() {
      this.init();
    },
  },
  created() {
    this.resetForm();
    this.bus.$on('resetForm', this.resetForm);
  },
  destroyed() {
    this.bus.$off('resetForm', this.resetForm);
  },
  mounted() {
    this.loading = false;
    this.init();
  },
  methods: {
    resetForm() {
      this.resetSorting('group');
    },
    init() {
      if (this.loading) {
        return;
      }
      this.loading = true;
      this.totalData = null;
      this.totalMeta = null;
      this.globalFrom = null;
      this.globalTo = null;
      if (this.filter.dateFrom !== undefined) {
        this.globalFrom = dayjs(this.filter.dateFrom)
          .hour(0)
          .minute(0)
          .second(0)
          .millisecond(0);
      }
      if (this.filter.dateTo !== undefined) {
        this.globalTo = dayjs(this.filter.dateTo)
          .hour(0)
          .minute(0)
          .second(0)
          .millisecond(0);
      }
      this.rootItem = {
        data: {
          level: 0,
          items: [],
          itemsMeta: {
            total: 0,
            count: 0,
            offset: -1,
          },
        },
        request: {
          dateFrom: this.filter.dateFrom,
          dateTo: this.filter.dateTo,
          groupBy: this.filter.group[0],
          periodGroup: this.filter.periodGroup,
          limit: this.pageSize,
          offset: 0,
          order: this.sorting.column,
          dir: this.sorting.dir,
        },
      };

      this.loadTotals({
        dateFrom: this.filter.dateFrom,
        dateTo: this.filter.dateTo,
        groupBy: undefined,
        periodGroup: undefined,
      }).then(() => {
        if (this.totalMeta !== null && this.totalMeta.total > 0) {
          this.loadItems(this.rootItem.request, this.rootItem.data);
        } else {
          this.loading = false;
        }
      });
    },
    applyFilters(request) {
      const res = clone(request);
      this.filter.groupFilter.forEach((value, key) => {
        if (
          this.filter.group[key] !== null
          && this.filter.groupFilter[key] !== null
          && !(
            res[`${this.filter.group[key].toLowerCase()}Ids`]
            && res[`${this.filter.group[key].toLowerCase()}Ids`].length
          )
        ) {
          res[`${this.filter.group[key].toLowerCase()}Ids`] = this.filter.groupFilter[key];
        }
      });
      return res;
    },
    loadTotals(request) {
      return this.loader(this.applyFilters(request)).then(({ data }) => {
        this.totalData = data.items[0];
        this.totalMeta = data.itemsMeta;
      }).catch((e) => {
        console.error(e);
      });
    },
    loadItems(request, container) {
      return this.loader(this.applyFilters(request)).then(({ data }) => {
        this.addItems(request, container, data.items, data.itemsMeta);
      }).catch((e) => {
        console.error(e);
      }).finally(() => {
        this.loading = false;
      });
    },
    addItems(request, data, items, itemsMeta) {
      items.forEach((it) => {
        const item = {
          row: it,
          request: clone(request),
          data: null,
        };
        item.request.groupBy = this.filter.group[data.level + 1];
        if (data.level < 4 && item.request.groupBy !== null) {
          item.data = {
            level: data.level + 1,
            items: [],
            itemsMeta: {
              total: 0,
              count: 0,
              offset: -1,
            },
          };
        }
        item.request.offset = 0;
        if (it.id !== '') {
          switch (request.groupBy) {
            case 'PERIOD': {
              let d = dayjs(get(it, 'group.name', ''));
              let d2;
              let range;
              switch (request.periodGroup) {
                case 'DAY':
                  d = d
                    .hour(0)
                    .minute(0)
                    .second(0)
                    .millisecond(0);
                  range = 'days';
                  set(it, 'group.name', d.format('DD.MM.YYYY'));
                  break;
                case 'WEEK': {
                  d = d
                    .hour(0)
                    .minute(0)
                    .second(0)
                    .millisecond(0);
                  range = 'weeks';
                  set(it, 'group.name', `${d.format('DD.MM.YYYY')} — ${d.clone().add(6, 'days').format('DD.MM.YYYY')}`);
                  break;
                }
                case 'MONTH':
                  d = d
                    .date(1)
                    .hour(0)
                    .minute(0)
                    .second(0)
                    .millisecond(0);
                  range = 'months';
                  set(it, 'group.name', d.format('MM.YYYY'));
                  break;
                case 'YEAR':
                  d = d
                    .month(0)
                    .date(1)
                    .hour(0)
                    .minute(0)
                    .second(0)
                    .millisecond(0);
                  range = 'years';
                  set(it, 'group.name', d.format('YYYY'));
                  break;
                default:
              }
              d2 = d.clone().add(1, range);
              // ограничиваем интервал глобальным перидом
              if (this.globalFrom !== null && d.isBefore(this.globalFrom)) {
                d = this.globalFrom.clone();
              }
              if (this.globalTo !== null && d2.isAfter(this.globalTo)) {
                d2 = this.globalTo.clone();
              }
              item.request.dateFrom = `${d.format('YYYY-MM-DDTHH:mm:ss')}+03:00`;
              item.request.dateTo = `${d2.format('YYYY-MM-DDTHH:mm:ss')}+03:00`;
              break;
            }
            default:
              item.request[`${request.groupBy.toLowerCase()}Ids`] = [it.id];
          }
        } else {
          item.request[`${request.groupBy.toLowerCase()}Ids`] = null;
        }
        data.items.push(item);
      });
      data.itemsMeta.total = itemsMeta.total;
      data.itemsMeta.offset = itemsMeta.offset;
      data.itemsMeta.count += itemsMeta.count;
    },
    onTryLoad(item) {
      if (item.data.itemsMeta.offset < 0) {
        this.loadItems(item.request, item.data);
      }
    },
    loadNext(item) {
      item.request.offset = item.data.itemsMeta.offset + this.pageSize;
      this.loadItems(item.request, item.data);
    },
    toggleSorting(col) {
      if (this.sorting.column === col) {
        this.sorting.dir = this.sorting.dir === 'ASC' ? 'DESC' : 'ASC';
      } else {
        this.sorting.column = col;
        this.sorting.dir = 'ASC';
      }
      this.init();
    },
    resetSorting(col) {
      this.sorting.column = col;
      this.sorting.dir = 'DESC';
    },
    getSortClass(col) {
      if (this.sorting.column === col) {
        return [this.sorting.dir === 'ASC' ? 'down' : 'up'];
      }
      return ['none'];
    },
  },
};

</script>

<style scoped lang="scss">
  @import "~/assets/scss/modules/_table-statistics.scss";
  @import "../../../../assets/css/pages/cabinet/_sorting-old.css";

  .block.more {
    display: flex;
    justify-content: flex-start;
    align-items: center;

    .button {
      display: block;
      outline: none;
      border: none;
      box-shadow: none;
    }

    .count {
      display: block;
      padding: 0 1rem;
      font-weight: 400;
      line-height: 1.3;
    }

    @media only screen and (min-width: 981px) {
      flex-flow: row nowrap;
      padding-bottom: 1rem;
      .button {
        height: 2rem;
        border-radius: 0.1875rem;
        padding: 0.25rem 2rem;
        background-color: #fff;
        border: 1px solid #9badb9;
        font-size: 0.8125rem;
        font-weight: 400;
        line-height: 1.3;
        cursor: pointer;

        &:hover {
          background-color: #e4ebf6;
        }
      }
      .count {
        font-size: 0.8125rem;
      }
      &.end {
        justify-content: center;
        padding-top: 1rem;

        .button {
          height: 2.5rem;
          padding: 0.5rem 2rem;
        }
      }
    }
    @media only screen and (max-width: 980px) {
      width: 100%;
      padding: 0;
      .button {
        width: 100%;
        margin: 1rem 0;
        color: #fff;
        background-color: #4272a4;
        border-radius: 0.25rem;
        font-weight: 500;
      }
      .count {
        font-size: 0.8125rem;
      }
      &:not(.end) {
        .button {
          height: 2.5rem;
          padding: 0.125rem 1rem;
          max-width: 9rem;
          font-size: 0.8125rem;
        }
      }
      &.end {
        flex-flow: column-reverse nowrap;
        padding-top: 2rem;

        .button {
          height: 3rem;
          padding: 0.25rem 1rem;
          max-width: 20rem;
          font-size: 1rem;
        }

        .count {
          font-size: 1rem;
        }
      }
    }
  }

  .question {
    position: relative;
    display: inline-flex;
    margin-left: 10px;

    > .button {
      display: inline-flex;
      justify-content: center;
      align-items: center;
      width: 1rem;
      height: 1rem;
      background: #fff;
      border: 1px solid #9badb9;
      border-radius: 50%;
      outline: 0;
      cursor: pointer;

      &:before {
        display: inline-flex;
        content: "?";
        font-size: 0.75rem;
        line-height: 1;
        color: #4272a4;
      }
    }
  }
</style>
